// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIColumn;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a UIComponent that represents a single column of data within a parent UISheet component.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ColumnTagDeclaration}.
 */
public class UIColumn
    extends AbstractUIColumn implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Column";

  public static final String COMPONENT_FAMILY = "javax.faces.Column";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    markup,
    resizable,
    paddingRight,
    label,
    sortable,
    align,
    borderTop,
    borderLeft,
    overflowX,
    paddingBottom,
    overflowY,
    borderRight,
    width,
    tip,
    paddingTop,
    borderBottom,
    paddingLeft,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Flag indicating whether or not the width of this column in a sheet is resizable, by the user.
  <br />Default: <code>true</code>
  */
  public boolean isResizable() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.resizable);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setResizable(boolean resizable) {
    getStateHelper().put(PropertyKeys.resizable, resizable);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingRight() {
    Object object = getStateHelper().eval(PropertyKeys.paddingRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingRight(org.apache.myfaces.tobago.layout.Measure paddingRight) {
    getStateHelper().put(PropertyKeys.paddingRight, paddingRight);
  }

  /**
  Text value to display as label. If text contains an underscore the next character is used as accesskey (if
   configured so and possible).

  */
  public java.lang.String getLabel() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.label);
  }

  public void setLabel(java.lang.String label) {
    getStateHelper().put(PropertyKeys.label, label);
  }

  /**
  Flag indicating whether or not this column is sortable. To make a column sortable the data of the sheet must be one
   of
   <code>java.util.List</code> or <code>Object[]</code>.
  <br />Default: <code>false</code>
  */
  public boolean isSortable() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.sortable);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setSortable(boolean sortable) {
    getStateHelper().put(PropertyKeys.sortable, sortable);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  Alignment of this column.

  */
  public java.lang.String getAlign() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.align);
  }

  public void setAlign(java.lang.String align) {
    getStateHelper().put(PropertyKeys.align, align);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderTop() {
    Object object = getStateHelper().eval(PropertyKeys.borderTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderTop(org.apache.myfaces.tobago.layout.Measure borderTop) {
    getStateHelper().put(PropertyKeys.borderTop, borderTop);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderLeft() {
    Object object = getStateHelper().eval(PropertyKeys.borderLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
   getRenderer(getFacesContext())).getBorderLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderLeft(org.apache.myfaces.tobago.layout.Measure borderLeft) {
    getStateHelper().put(PropertyKeys.borderLeft, borderLeft);
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowX() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.overflowX);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOverflowX(boolean overflowX) {
    getStateHelper().put(PropertyKeys.overflowX, overflowX);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingBottom() {
    Object object = getStateHelper().eval(PropertyKeys.paddingBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingBottom(org.apache.myfaces.tobago.layout.Measure paddingBottom) {
    getStateHelper().put(PropertyKeys.paddingBottom, paddingBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowY() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.overflowY);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOverflowY(boolean overflowY) {
    getStateHelper().put(PropertyKeys.overflowY, overflowY);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderRight() {
    Object object = getStateHelper().eval(PropertyKeys.borderRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderRight(org.apache.myfaces.tobago.layout.Measure borderRight) {
    getStateHelper().put(PropertyKeys.borderRight, borderRight);
  }

  /**
  The layout token for this column. Allowd layout tokens ('*', '&lt;x>*', '&lt;x>px' or '&lt;x>%'). Where '*' is
   equivalent to '1*'.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    Object object = getStateHelper().eval(PropertyKeys.width);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    getStateHelper().put(PropertyKeys.width, width);
  }

  /**
  Text value to display as tooltip.

  */
  public java.lang.String getTip() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.tip);
  }

  public void setTip(java.lang.String tip) {
    getStateHelper().put(PropertyKeys.tip, tip);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingTop() {
    Object object = getStateHelper().eval(PropertyKeys.paddingTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingTop(org.apache.myfaces.tobago.layout.Measure paddingTop) {
    getStateHelper().put(PropertyKeys.paddingTop, paddingTop);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderBottom() {
    Object object = getStateHelper().eval(PropertyKeys.borderBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderBottom(org.apache.myfaces.tobago.layout.Measure borderBottom) {
    getStateHelper().put(PropertyKeys.borderBottom, borderBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingLeft() {
    Object object = getStateHelper().eval(PropertyKeys.paddingLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingLeft(org.apache.myfaces.tobago.layout.Measure paddingLeft) {
    getStateHelper().put(PropertyKeys.paddingLeft, paddingLeft);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}