// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.el.MethodExpression;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUISuggest;
import org.apache.myfaces.tobago.model.SuggestFilter;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a list of suggested texts for a given input field.
  <p>
  Basic features:
  <ul>
    <li>provide a list directly while rendering (not AJAX needed) [todo]</li>
    <li>update by typing (AJAX)</li>
    <li>minimum number of typed characters (to avoid useless requests)</li>
    <li>update delay (useful for optimization)</li>
    <li>filter on client side (useful for optimization) [todo]</li>
  </ul>
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.SuggestTagDeclaration}.
 */
public class UISuggest
    extends AbstractUISuggest implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Suggest";

  public static final String COMPONENT_FAMILY = "javax.faces.Input";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    filter,
    delay,
    markup,
    suggestMethod,
    minimumCharacters,
    update,
    totalCount,
    maximumItems,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  TODO: not implemented yet
   <p/>
   Additional client side filtering of the result list.
   This is useful when sending the full list initially to the client and
   setting <code>update=false</code>.
   <p/>
   Possible values are:
   <dl>
     <dt>all</dt>
     <dd>no filtering</dd>
     <dt>prefix</dt>
     <dd>checks if the suggested string starts with the typed text</dd>
     <dt>contains</dt>
     <dd>checks if the typed text is inside of the suggested string</dd>
   </dl>
   <p/>
   The filter will only applied on the client side and
   only if server updated (by AJAX) are turned off (<code>update=false</code>);
  <br />Default: <code>SuggestFilter.ALL</code><br />Allowed Values: <code>all,prefix,contains</code>
  */
  public org.apache.myfaces.tobago.model.SuggestFilter getFilter() {
    org.apache.myfaces.tobago.model.SuggestFilter filter = (org.apache.myfaces.tobago.model.SuggestFilter) getStateHelper().eval(PropertyKeys.filter);
    if (filter != null) {
      return filter;
    }
    return SuggestFilter.ALL;
  }

  public void setFilter(org.apache.myfaces.tobago.model.SuggestFilter filter) {
    getStateHelper().put(PropertyKeys.filter, filter);
  }

  /**
  Time in milli seconds before the list will be requested (by AJAX).
  <br />Default: <code>300</code>
  */
  public java.lang.Integer getDelay() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.delay);
    if (value != null) {
      return value.intValue();
    }
    return 300;
  }

  public void setDelay(java.lang.Integer delay) {
    getStateHelper().put(PropertyKeys.delay, delay);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getSuggestMethod() {
    javax.el.MethodExpression expression = getSuggestMethodExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setSuggestMethod(javax.faces.el.MethodBinding suggestMethod) {
    if (suggestMethod != null) {
      setSuggestMethodExpression(new MethodBindingToMethodExpression(suggestMethod));
    } else {
      setSuggestMethodExpression(null);
    }
  }

  public javax.el.MethodExpression getSuggestMethodExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.suggestMethod);
  }

  public void setSuggestMethodExpression(javax.el.MethodExpression suggestMethod) {
    getStateHelper().put(PropertyKeys.suggestMethod, suggestMethod);
  }


  /**
  Minimum number of characters to type before the list will be requested. If the value is 0, there will be send an
   initial list to the client. So, if you set <pre>update="false"</pre> this value should be 0.
  <br />Default: <code>1</code>
  */
  public java.lang.Integer getMinimumCharacters() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.minimumCharacters);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setMinimumCharacters(java.lang.Integer minimumCharacters) {
    getStateHelper().put(PropertyKeys.minimumCharacters, minimumCharacters);
  }

  /**
  TODO: not implemented yet
   <p>
   Should the list be updated while typing (via AJAX). This is the default behaviour.
   If you set this value to <code>false</code>, please set the <code>minimumCharacters="0"</code>.
  <br />Default: <code>true</code>
  */
  public boolean isUpdate() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.update);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setUpdate(boolean update) {
    getStateHelper().put(PropertyKeys.update, update);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  The real size of the result list. Typically the result list will be cropped (in the backend) to save memory. This
   value can be set, to show the user there are more results for the given string. If the value is -1, no hint will be
   displayed.
  <br />Default: <code>-1</code>
  */
  public java.lang.Integer getTotalCount() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.totalCount);
    if (value != null) {
      return value.intValue();
    }
    return -1;
  }

  public void setTotalCount(java.lang.Integer totalCount) {
    getStateHelper().put(PropertyKeys.totalCount, totalCount);
  }

  /**
  The maximum number of item to display in the drop down list.
  <br />Default: <code>10</code>
  */
  public java.lang.Integer getMaximumItems() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.maximumItems);
    if (value != null) {
      return value.intValue();
    }
    return 10;
  }

  public void setMaximumItems(java.lang.Integer maximumItems) {
    getStateHelper().put(PropertyKeys.maximumItems, maximumItems);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}